#!/bin/sh

prefix="/opt/op5/monitor"

if ! $(mysql monitor_gui -Be "SHOW TABLES" | grep "smap_view" > /dev/null); then
    # Table do not exist so we create it
    mysql monitor_gui < $prefix/op5/networkmap/smap.sql
    mysql monitor_gui -e "ALTER TABLE smap_view ADD is_hostgroup tinyint(3) unsigned" >& /dev/null
    mysql monitor_gui -e "UPDATE smap_view RIGHT JOIN hostgroup ON smap_view.name=hostgroup.hostgroup_name SET smap_view.is_hostgroup=1"
    mysql monitor_gui -e "UPDATE smap_view SET name='Root view' WHERE name='*' AND id=1"
fi
