<?php
/*
 * Copyright(C) op5 AB
 * All rights reserved.
 */

session_start();

require_once('/opt/monitor/op5/gui/gui_api.inc.php');
require_once('/opt/monitor/op5/gui/status.inc.php');
require_once('smap_utils.inc.php');
require_once('./smap_config.inc.php');


$ret = gui_init();

global $auth;
global $auth_for_all;
get_auth_for_all();
if($ret === true) {
	smap_db_sync();
}
$x = false;
$y = false;
if(isset($_REQUEST['x'])) $x = $_REQUEST['x'];
if(isset($_REQUEST['y'])) $y = $_REQUEST['y'];
$edit_mode='map';
if(isset($_REQUEST['edit_mode'])) $edit_mode = $_REQUEST['edit_mode'];
if(!empty($_REQUEST['content'])) $this_content = $_REQUEST['content'];


// by request or session (must eval $_REQUEST first, or we can't change it)
$refresh = '90';
$view = '1';
$map_mode = 'view';
$background = false;
$background = BACKGROUND;
$scale = '1.0';
$error_msg = "";

/* If changing from hostgroup to custom view or wise versa the view */
/* param needs to be updated, using the first in the dropdown... */
$changed_mode=0;
if(isset($_REQUEST['map_mode']) && isset($_REQUEST['map_mode_old']) && $_REQUEST['map_mode_old'] != $_REQUEST['map_mode']){
	if(($_REQUEST['map_mode_old']==="edit" && $_REQUEST['map_mode']!="view") ||
   	   ($_REQUEST['map_mode_old']==="view" && $_REQUEST['map_mode']!="edit") ||
   	   ($_REQUEST['map_mode_old']==="edit_custom" && $_REQUEST['map_mode']!="view_custom") ||
       ($_REQUEST['map_mode_old']==="view_custom" && $_REQUEST['map_mode']!="edit_custom")){

	$changed_mode=1;
	}
}



if(isset($_REQUEST['map_mode'])) $map_mode = $_REQUEST['map_mode'];
elseif(isset($_REQUEST['map_mode_old'])) $map_mode = $_REQUEST['map_mode_old'];

if(isset($_REQUEST['view'])) $view = $_REQUEST['view'];
elseif(isset($_SESSION['view'])) $view = $_SESSION['view'];
if(!is_numeric($view)) $view = '1';

if(isset($_REQUEST['scale'])){
	$scale = $_REQUEST['scale'];
	$_SESSION['scale']=$scale;
}
elseif(isset($_SESSION['scale'])) $scale = $_SESSION['scale'];
if(!is_numeric($scale) || empty($scale)) $scale = '1.0';


if(isset($_REQUEST['refresh'])) $refresh = $_REQUEST['refresh'];
elseif(isset($_SESSION['refresh'])) $refresh = $_SESSION['refresh'];
if(!is_numeric($refresh) || $refresh < 10) $refresh = '90';

$edit_option="option_map";
if(isset($_REQUEST['edit_option'])){
	$edit_option = $_REQUEST['edit_option'];
}
elseif(isset($_SESSION['edit_option'])){
	$edit_option = $_SESSION['edit_option'];
}

/* map_mode is not set when first loading */
if(!isset($_REQUEST['map_mode_old'])){
	$view=1;
	$map_mode="view_custom";
	$changed_mode=1;
}


/* Delete a background */
if(isset($_REQUEST['delete_bg']) && $auth_for_all){
	$deleting=$_REQUEST['delete_bg'];
	if($deleting!=""){
		$deleting = @unlink(BG_DIR . "/" . $_REQUEST['delete_bg'] . ".png");
		if(!$deleting){
		  $error_msg =  "Failed to delete background.<br \> " .
		  				"This might be related to file permissions.";
		}
	}
}

if(isset($_REQUEST['delete_view']) && $auth_for_all){
	delete_view_recursive($view);
	$changed_mode=1;
}
if(isset($_REQUEST['rename_view']) && $auth_for_all){
	$new_view_name=$_REQUEST['new_view_name'];
    $new_view_name=trim($new_view_name);
	if(!$new_view_name==''){
		$success=rename_view($view, $_REQUEST['new_view_name']);
		if(!$success){
			$error_msg = "The choosen name allready exists as view or hostgroup. <BR />" .
		  				 "View has NOT been renamed.";
		}
	}
}

if($changed_mode===1){
	if(($map_mode==="view_custom") || ($map_mode==="edit_custom")){
		$view=1;
	}
	if($map_mode==="edit" || $map_mode==="view"){
		$view=get_first_view();
	}
}

if(isset($_REQUEST['default_bg']) && $auth_for_all){
	$edit_option="handle_background";
	$bg_link = BG_DIR . "/default";
	$new_default_bg = $_REQUEST['default_bg'];
	if(Is_link($bg_link)){
		unlink($bg_link);
	}
	symlink($new_default_bg, $bg_link);
}


// by session or pulldown menu or get_clicked_object(x, y);
$selected_host = false;
$selected_view = false;
$sel = false;

if(isset($_REQUEST['selected'])) {
	$sel = $_REQUEST['selected'];
	if(!empty($sel)) {
		if(is_numeric($sel)) {
			$selected_view = $sel;
		}
		elseif(is_string($sel)) {
			$selected_host = $sel;
		}
		else {
			$sel = false;
		}
	}
}


if(!empty($_REQUEST['change']) && (!empty($_REQUEST['bg_change'])) && $auth_for_all){
	$background = $_REQUEST['bg_change'];
	/* skapa function i smap_utils.... */
	sql_exec_query('UPDATE smap_view SET background = \'' .
				   mysql_escape_string($background) . '\'' .
				   "WHERE id = '$view'");
	update_coords($view, $background);
}

/* New custom view */
if(!empty($_REQUEST['new_view']) && $auth_for_all){
	$new_view_name=$_REQUEST['new_view'];
    $new_view_name=trim($new_view_name);
    if($new_view_name!=''){
    	$new_view_id=add_view($new_view_name, $_REQUEST['parentView']);
		if($new_view_id===0){
			$error_msg = "The choosen name allready exists as view or hostgroup. <BR />" .
			  			 "View has NOT been added";
		} else {
        	$view=$new_view_id;
		}
	}
}


if(!empty($_REQUEST['add_to_map']) && $auth_for_all){
	/* Add host to view  */
	if(!empty($_REQUEST['addHost3'])){
		$newHost=$_REQUEST['addHost3'];
		foreach($newHost as $host){
			add_host_to_view($host, $view);
		}
	}

	/* Adding view */
	if(!empty($_REQUEST['addView3'])){
		$newView = $_REQUEST['addView3'];
		foreach($newView as $the_view){
			add_view_to_view($the_view, $view);
		}
	}
}


if(!empty($_REQUEST['delete_from_map']) && $auth_for_all){
	/* Delete host from view */
	if(!empty($_REQUEST['deleteHost'])){
		$newHost=$_REQUEST['deleteHost'];
		foreach($newHost as $host){
			delete_host_from_view($host, $view);
		}
	}
	/* Delete view from view */
	if(!empty($_REQUEST['deleteView'])){
		$newView=$_REQUEST['deleteView'];
		foreach($newView as $the_view){
			delete_view_from_view($the_view, $view);
		}
	}
	if(!empty($_REQUEST['deleteCustomView'])){
		$newView=$_REQUEST['deleteCustomView'];
		foreach($newView as $the_view){
			delete_view_recursive($the_view);
		}
	}
}


if(!empty($x) && !empty($y) && ($map_mode === 'edit' || $map_mode==='edit_custom') &&
   ($selected_view || $selected_host)  && $auth_for_all) {
	update_coordinates($x, $y, $selected_host, $selected_view);
	$selected_view = $selected_host = $x = $y = false;
}

$_SESSION['refresh'] = $refresh;
$_SESSION['view'] = $view;
$_SESSION['map_mode'] = $map_mode;
setcookie("map_mode_old", $map_mode);
if($map_mode === 'edit') {
	$_SESSION['selected_host'] = $selected_host;
	$_SESSION['selected_view'] = $selected_view;
}

$sel = $selected_view = $selected_host = false;
$sel = get_clicked_object($x, $y);
if(!empty($sel)) {
	if(is_numeric($sel)) {
		$selected_view = $sel;
	}
	elseif(is_string($sel)) {
		$selected_host = $sel;
	}
}

if($map_mode !== 'edit' && $map_mode !== 'edit_custom' && !empty($selected_view)){
	$view = $selected_view;
}
if($map_mode !== 'edit' && $map_mode !== 'edit_custom' && !empty($selected_host)) {
	if(isset($_SESSION['selected_host'])) {
		unset($_SESSION['selected_host']);
	}
	if(isset($_SESSION['selected'])) {
		unset($_SESSION['selected']);
	}
	// redirect to status.cgi?host=$selected_host
	echo "<html><head><meta http-equiv='REFRESH' content='0; URL=" . CGI_URL . "/status.cgi?host=$selected_host' /></head><body></body></html>\n";
	exit(0);
}

/* special case, when clicking a hostgroup from custom view, we need to */
/* change view variable so that dropdownlists show the right stuff */
if($map_mode==="view_custom" && $view!=1){
	$map_mode="view";
	$_SESSION['map_mode']="view";
	setcookie("map_mode_old","view");
	$custom_views = get_all_custom_viewsR(1,''); // access ok
	/* loop through all custom views, if current view is custom, */
	/* set map_mode='view_custom', else = 'view' */
	foreach($custom_views as $id => $val){
		if($view==$id){
			$map_mode="view_custom";
			$_SESSION['map_mode']="view_custom";
			setcookie("map_mode_old","view_custom");
		}
	}
}



// main page printout
$backgrounds = get_map_backgrounds();
html_start();

if($map_mode !== 'edit' && $map_mode !== 'edit_custom') {
	echo '<meta http-equiv="refresh" content="'.$refresh.'; url=\''.$_SERVER['PHP_SELF'].'?'.$_SERVER['QUERY_STRING'].'\'" />'."\n";
}
else {
	echo '<meta http-equiv="content-type" content="application/xhtml+xml; charset=iso-8859-1" />'."\n";
}
/* Build the treeview over custom maps */
echo "<script type=\"text/javascript\" src=\"tree/dtree.js\"></script>\n" .
  	  "<script type=\"text/javascript\">\n" .
  	  "<!--\n" .
     "var Tree = new Array;\n";
echo "a= new dTree('a');\n";
$i=0;

$root_name=get_root_name();
echo "a.config.useCookies=true;\n" .
  	 "a.config.useIcons=false;\n";
echo "a.add(1,-1,'$root_name', " .
  	 "'smap.php?map_mode=edit_custom&view=1', '','_self');\n" ;
$tmp=get_custom_view_info();
if (is_array($tmp) && !empty($tmp)) {
	foreach($tmp as $row){
		$the_view = $row['view'];
		$the_smap_view = $row['smap_view'];
		$name = $row['name'];
		echo "a.add($the_view, $the_smap_view, '$name', ".
			"'smap.php?map_mode=edit_custom&view=$the_view', '','_self');\n" ;
	}
}
echo  	" //-->\n";

echo "function globalEdit() {
	document.myForm.edit_mode.value='global';
	document.myForm.submit();
}
function localEdit() {
	document.myForm.edit_mode.value='map';
	document.myForm.submit();
}";

echo "</script>\n</head>\n\n<body>\n";
/* tree build done... */

$user = $_SERVER['REMOTE_USER'];
$date_str = date('D M H:i:s T Y');

/* Top table,   */
//echo '<div id="text" style="padding-bottom: 0px"><h2>Network Map</h2></div>';
/* Top-right link-box */
//echo '<div class="clear"></div>';

/* Title links (Edit global or map-settings) */

echo '<form name="myForm" action="'.$_SERVER['PHP_SELF'].'" method="get">'."\n";
echo '<div>';
echo '<input type="hidden" name="edit_mode" value="'.$edit_mode.'" />';


echo '<div style="padding: 7px 14px;">';
echo '<ul>';
echo "<li><a href='javascript:localEdit()'>View&nbsp;settings</a></li>";
echo "<li><a href='javascript:globalEdit()'>Global&nbsp;settings</a></li>";
echo '</ul>';


/* If edit_mode='map' edit map settings, else
 global setttings (refresh rate and zoom) */
if($edit_mode=='map'){
	echo "Map mode &nbsp;";
	echo "<select name='map_mode' onchange='this.form.submit()'>\n"; // onchange='this.form.submit()'>\n";
	echo "<option value='view'";
	if ($map_mode === 'view') echo 'selected="selected"';
	echo ">View hostgroup</option>\n";
	echo "<option value='view_custom'";
	if ($map_mode === 'view_custom') echo 'selected="selected"';
	echo ">View custom map</option>\n";
	if($auth_for_all){
		echo "<option value='edit'";
		if ($map_mode === 'edit') echo 'selected="selected"';
		echo ">Edit hostgroup</option>\n";
		echo "<option value='edit_custom'";
		if ($map_mode === 'edit_custom') echo 'selected="selected"';
		echo ">Edit custom map</option>\n";
	}
	echo "</select>\n\n";

	/* Hostgroup or custom map selectionbox */
	if($map_mode==='edit' || $map_mode==='view'){
		echo "Hostgroup ";
		$all_views=get_all_hostgroups(1);
		echo "<select name='view' onchange='this.form.submit()'>\n";
		foreach($all_views as $id => $one_view){
			if($id == $view){
				echo "<option value='$id' selected=\"selected\">$one_view</option>\n";
			} else {
				echo "<option value='$id'>$one_view</option>\n";
			}
		}
		echo '</select>';
	} else {
		echo "Custom map &nbsp;";
		$all_views=get_all_custom_viewsR(1,"- ");
		$root_name=get_root_name();
		echo "<select name='view' onchange='this.form.submit()'>\n";
		if($view==1){
			echo "<option value='1' selected=\"selected\">$root_name</option>\n";
		} else {
			echo "<option value='1'>$root_name</option>\n";
		}
		foreach($all_views as $id => $one_view){
			if($id == $view){
				echo "<option value='$id' selected=\"selected\">$one_view</option>\n";
			} else {
				echo "<option value='$id'>$one_view</option>\n";
			}
		}
		echo '</select>';
	}

	/* Object (Hosts and hostgroups) selection box */
	if(($map_mode==='edit' || $map_mode==='edit_custom') && $auth_for_all){
		  "<form action='$_SERVER[PHP_SELF]' method='GET'>";
		$obj_list = get_content($view); // access ok...
		echo "\n\nSelect object &nbsp;\n";

		echo "<select name='selected'>\n";
		echo "<option value=''></option>\n";
		foreach($obj_list as $k => $name) {
			if($name === $selected_host || $k == $selected_view) {
				echo "<option selected=\"selected\" value='$k'>$name</option>\n";
				continue;
			}
			echo "<option value='$k'>$name</option>\n";
		}
		echo "</select>\n";
	}

	if($map_mode==='edit' || $map_mode==='edit_custom'){
		echo "Background &nbsp;\n";

		echo "<select name='bg_change'>\n";
		echo "<option value=''></option>\n";

		$background=get_map_background($view);
		foreach($backgrounds as $bg2) {
			echo "<option value='$bg2'";
			if($bg2 == $background) echo 'selected="selected"';
			echo ">$bg2</option>\n";
		}
		echo "</select>\n";
		echo "<input type='submit' name='change' value='Change' />";
	}
} else {
	# $edit_mode isn't "map"
	/* Global settings: resh-rate and scale */
	echo "Refresh rate";
	echo "<input type=\"text\" size='3' maxlength='3' name='refresh'
		   value='$refresh' title='Page refresh rate in seconds' />";

	echo "Map scale";
	echo "<input type=\"text\" size='4' maxlength='4' name='scale'
		   value='$scale' title='Map zoom factor (1=normal, 2=double)' />";

	echo "<input type='submit' name='change' value='Change' />";

}


$cursor = 'hand';

/********************************************************/
/* End of top table, start of image and edit table... 	*/
/********************************************************/

/* Edit stuff, only when in 'edit_custom' mode */
/* Outer=big table with 2 columns, edit stuff in left, map in right */
/* outer has t*/

if($map_mode==='edit_custom'){
	/* Draw the custom map tree */
	echo '</div>';

	echo '<table class="max" cellspacing="0" cellpadding="0" summary="">'; //inner 2
	echo "<tr><th>Custom view tree</th></tr>\n";
	echo '<tr class="button"><td>';
	echo  "<script type=\"text/javascript\">\n\n" .
               "<!--\n" .
               "document.write(a);\n";
    echo       "//-->\n" .
               "</script>\n\n";
	echo '</td></tr>';
}

if($map_mode==='edit_custom'){
	echo "<tr class=\"button\"><td>Select task &nbsp;";
	echo "<select name='edit_option' onchange='this.form.submit()'>\n";
	echo "<option value='option_map'";
	if($edit_option==='option_map') echo " selected=\"selected\"";
	echo ">Create new custom view</option>\n";
	echo "<option value='option_rename_view'";
	if($edit_option==='option_rename_view') echo " selected=\"selected\"";
	echo ">Rename this view</option>\n";
	echo "<option value='option_add'";
	if($edit_option==='option_add') echo " selected=\"selected\"";
	echo ">Add item to this view</option>\n";
	echo "<option value='option_del'";
	if($edit_option==='option_del') echo " selected=\"selected\"";
	echo ">Remove item from this view</option>\n";
	if($view!=1){
		echo "<option value='option_del_view'";
		if($edit_option==='option_del_view') echo " selected=\"selected\"";
		echo ">Delete this view</option>\n";
	}
	echo "<option value='handle_background'";
	if($edit_option==='handle_background') echo " selected=\"selected\"";
	echo ">Handle background images</option>\n";
	echo "</select>\n";
	echo "</td></tr>\n";
}

if($map_mode==='edit_custom' && $error_msg!=""){
	echo "<tr class=\"error\"><td>"; //inner 2
	echo $error_msg;
	echo "</td></tr>";
}
	echo '</table>';


/* Add new custom view */
if($map_mode==='edit_custom' && $edit_option==='option_map'){
	echo "</div>";
	echo '<table class="max" cellspacing="0" cellpadding="0" summary="">'; //inner 2
	echo '<colgroup span="2"><col class="w150"></col><col></col></colgroup>';
	echo "<tr><th colspan='2'>Create new custom view</th></tr>\n";
	echo "<tr class=\"odd\"><td>";
	echo "Name </td><td><input type=\"text\" name='new_view' " .
         "maxlength='30' /></td></tr>\n";
	echo "<tr class=\"even\"><td>Parent</td><td>" .
	  	 "<select name='parentView'>\n";
	$tmp = get_all_custom_viewsR(1,'- ');
	$root_name=get_root_name();
	echo "<option value='1'>$root_name</option>\n";
	foreach($tmp as $id => $name){
		if($id == $view){
			echo "<option value='$id' selected=\"selected\">$name</option>\n";
		} else {
		    echo "<option value='$id'>$name</option>\n";
		}
	}
	echo "</select>\n";
	echo "</td></tr>\n\n";
	echo "<tr class=\"button\"><td colspan='2'>\n";
	echo "<input type='submit' value='Add custom view' name='update_view_content2' />";
	echo "</td></tr>\n</table>\n";
}


/* Remove stuff from custom view */
if($map_mode==='edit_custom' && $edit_option==='option_del'){
	echo "&nbsp\n";
	echo '<table class="max" cellspacing="0" cellpadding="0" summary="">'; //inner 2
	echo '<colgroup span="2"><col class="w150"></col><col></col></colgroup>';
	echo "<tr><th colspan='2'>";
	echo "Remove items from this view</th></tr>\n";

	$the_views = get_hostgroups_in_view($view);
    $all_views= get_all_views2($view);
	echo "<tr class=\"odd\"><td>Hostgroups</td><td>";

	$num_views = count($the_views);
	$num_rows=$num_views;
	if ($num_views===0) {
		echo "<i>No hostgroups in view</i>";
	} else {
		if ($num_views>5){
		  $num_rows=5;
		}
		echo "<select multiple name='deleteView[]' size='". $num_rows . "'>\n";
	    while(list ($view_id, $view_name)= each($all_views)){
	       if (in_array($view_name,$the_views)){
	            echo "<option value='$view_id'>$view_name</option>\n";
			}
		}
    	echo "</select>\n </td></tr>\n";
	}
	echo "<tr class=\"even\"><td>";

	echo "Hosts</td>\n";
	echo "<td>";

	$hosts_in_view = get_host_in_view($view);
    $all_hosts= get_all_hosts();

	$num_hosts=count($hosts_in_view);
	$num_rows=$num_hosts;
  	if($num_hosts===0){
		echo "<i>No hosts in view</i>";
	} else {
		if($num_hosts>5){
		  $num_rows=5;
		}
    	echo "<select multiple name='deleteHost[]' size='" . $num_rows  . "'>\n";
    	foreach($all_hosts as $host){
			if (in_array($host,$hosts_in_view)){
				echo "<option value='$host'>$host</option>\n";
			}
		}
    	echo "</select>\n </td></tr>\n";
	}
	echo "<tr class=\"odd\"><td>";

	echo "Custom views</td>\n";
	echo "<td>\n";

	$views_in_view = get_customview_in_view($view);
    $all_views= get_custom_view_info();

	$num_views=count($views_in_view);
	$num_rows=$num_views;
  	if($num_views===0){
		echo "<i>No custom views in view</i></td>";
	} else {
		if($num_views>5){
		  $num_rows=5;
		}
    	echo "<select multiple name='deleteCustomView[]' size='" . $num_rows  . "'>\n";
    	foreach($all_views as $row){
			if (key_exists($row['view'],$views_in_view)){
				echo "<option value='" . $row['view'] ."'>" . $row['name'] . "</option>\n";
			}

		}
    	echo "</select>\n </td></tr>\n";
	}
	echo "<tr class=\"button\"><td colspan='2'>
		  <input type='submit' value='Remove selected from view' name='delete_from_map' />";
	echo "</td></tr></table>\n";
}

/* Add stuff to custom view */
if($map_mode==='edit_custom' && $edit_option==='option_add'){
	echo "&nbsp\n";
	echo '<table class="max" cellspacing="0" cellpadding="0" summary="">'; //inner 2
	echo '<colgroup span="2"><col class="w150"></col><col></col></colgroup>';
	echo "<tr><th colspan='2'>Add items to this view</th></tr>\n";
	echo "<tr class=\"odd top\"><td>Hostgroups</td>";

	$the_views = get_hostgroups_in_view($view);
    $all_views= get_all_views2($view);
	$num_views = count($all_views) -  count($the_views);
	$num_rows=$num_views;
	if ($num_views===0) {
		echo "<td><i>All hostgroups added</i>";
	} else {

		if ($num_views>5){
		  $num_rows=5;
		}
		echo "<td><select multiple name='addView3[]' size='" . $num_rows . "'>\n";
	    while(list ($view_id, $view_name)= each($all_views)){
	       if (!in_array($view_name,$the_views)){
	            echo "<option value='$view_id'>$view_name</option>\n";
			}
		}
    	echo "</select>\n";
	}
	echo "</td></tr>\n";
	echo "<tr class=\"even top\"><td>";
    echo "Hosts</td>\n";
	echo "<td>";

	$hosts_in_view = get_host_in_view($view);
    $all_hosts= get_all_hosts();
	$num_hosts = count($all_hosts) -  count($hosts_in_view);
	$num_rows=$num_hosts;

  	if($num_hosts===0){
		echo "<i>All hosts added</i>";
	} else {

		if($num_hosts>5){
		  $num_rows=5;
		}
	    echo "<select multiple name='addHost3[]' size='" . $num_rows . "'>\n";
    	$hosts = get_host_in_view($view);
    	$all_hosts= get_all_hosts();

    	foreach($all_hosts as $host){
			if (!in_array($host,$hosts)){
		    	echo "<option value='$host'>$host</option>\n";
			}
		}
    	echo "</select>\n </td></tr>\n";
	}
	echo "<tr class=\"button\"><td colspan='2'>
		  <input type='submit' value='Add selected to map' name='add_to_map' />";
	echo "</td></tr>\n";
	echo "</table>\n";
}

/* Delete this custom view */
if($map_mode==='edit_custom' && $edit_option==='option_del_view'){
	echo "&nbsp\n";
	echo '<table class="max" cellspacing="0" cellpadding="0" summary="">'; //inner 2
	echo "<tr><th>Delete this view (and all its children)</th></tr>";

	echo "<tr class=\"button\"><td><input type='submit' value='Delete view' name='delete_view' />";
	echo "</td></tr>\n</table>\n";
}

/* Rename this view */
if($map_mode==='edit_custom' && $edit_option==='option_rename_view'){
	echo "</div>";
	echo '<table class="max" cellspacing="0" cellpadding="0" summary="">'; //inner 2
	echo '<colgroup span="2"><col class="w150"></col><col></col></colgroup>';
	echo "<tr><th colspan='2'>Rename this view</th></tr>\n";
	echo "<tr class=\"odd\"><td>Name for this view</td>";
	echo "<td>";
	echo "<input type=\"text\" size='15' maxlength='20' name='new_view_name' class=\"xlarge\"/>";
	echo "</td></tr>";
	echo "<tr class=\"button\"><td colspan=\"2\"><input type='submit' value='Rename' name='rename_view' /></td></tr>";
	echo "</table>\n\n";
}


/* Handle background. Set default bg or change bg for this view */
if($map_mode==='edit_custom' && $edit_option==='handle_background'){
	echo "</form>";
	echo '<table class="max" cellspacing="0" cellpadding="0" summary="">'; //inner 2
	echo '<colgroup span="2"><col class="w150"></col><col></col></colgroup>';
	echo "<tr><th colspan=\"2\">Handle background images</th></tr>";
	echo '<tr class="odd"><td>Upload background image (png format)</td>';
	echo "<td>
			<form enctype='multipart/form-data' action='upload_file.php?caller=statusmap' method='post'>
			<div>
		   <input type='hidden' name='MAX_FILE_SIZE' value='1000000' />
		   <input name='toProcess' size=\"10\" type='file' accept='image/png' />
		   <input type='submit' value='Upload' /></div>
		   </form></td></tr>";

	echo "<tr class=\"even\"><td>Set default background</td>\n";
	echo "<td><form action='$_SERVER[PHP_SELF]' method='get'><div>";

	echo "<select name='default_bg'>\n";
	echo "<option value=''></option>\n";
	$background=get_default_background();
    foreach($backgrounds as $bg2) {
		echo "<option value='$bg2'";
		if($bg2 == $background) echo 'selected="selected"';
		echo ">$bg2</option>\n";
	}
	echo "</select>\n";
 	echo "<input type='submit' value='Set as default' name='set_default_bg' />";
	echo "</td></tr>";
	echo "<tr class=\"odd\"><td>Delete background</td>\n";
	echo "<td>";

	echo "<select name='delete_bg'>\n";
	echo "<option value=''></option>\n";
	$background=get_default_background();
    foreach($backgrounds as $bg2) {
       	if($bg2 != $background) {
			echo "<option value='$bg2'>$bg2</option>\n";
		}
	}
	echo "</select>\n";
 	echo "<input type='submit' value='Delete selected' name='delete_this_bg' />";
	echo "</td></tr>";
	echo "</table>";
}


/* Print hostgroup/view */
echo '</div>';
echo '<table class="max" cellpadding="0" cellspacing="0" summary="">';
echo '<tr><th>';
if($map_mode==='view' || $map_mode==='edit'){
	    echo "Current hostgroup: ";
} else {
	    echo "Current custom view: ";
}
echo "<strong>".get_view_name($view)."</strong>";
echo '</th></tr></table>';

/* The network map */
echo "<br /><a name='showimage'></a>";
echo "<i style='cursor: $cursor;'>\n";
echo "<input type='image' src='smap_img.php?view=$view&amp;scale=$scale' style=\"border: 0px\" />";
echo "</i>\n";

echo "</div>\n";
echo "</form>\n";

echo "\n</body>\n</html>\n";

?>
